
SegVideo       EQU      0B800H         ;Endereco do segmento de video
NumBytesVid    EQU      (80*2)*25      ;80 Colunas(caracter,atributo),25 linhas
Zero           EQU      0              ;
EnterKey       EQU      0DH            ;Valor da tecla ENTER
Atrib          EQU      0FH            ;Valor do atributo normal de video
Espaco         EQU      ' '            ;Espaco para apagar o caracteres da tela
Aster1         EQU      186            ;Primeiro asteroide
Aster2         EQU      254            ;Primeiro asteroide
Aster3         EQU      249            ;Primeiro asteroide
Aster4         EQU      219            ;Primeiro asteroide
Nave           EQU      127            ;Nave do usuario
Explosao       EQU      15             ;Explosao de impacto
Raio           EQU      19             ;Tiro do usuario
Direita        EQU      '6'            ;A tecla 6 move a nave para a direira
Esquerda       EQU      '4'            ;A tecla 4 move a nave para a esquerda

DOS10          EQU      10H            ;Chamada de interrupcao do DOS 10H
DOS21          EQU      21H            ;Chamada de interrupcao do DOS 21H

CODIGO         SEGMENT PARA 'CODE'

               ASSUME      CS:CODIGO, DS:CODIGO, ES:CODIGO, SS:CODIGO

               ORG      100H           ;255 bytes de informacao do DOS

INICIO:        JMP      CONTROLE

NAVECOLUNA     DB       40             ;Coluna da nave do usuario
TIROCOLUNA     DB       40             ;Coluna do tiro do usuario
TIROLINHA      DB       24             ;Linha atual do tiro do usuario
ASTER1COLUNA   DB       10             ;Coluna do primeiro asteroide
ASTER2COLUNA   DB       30             ;Segundo asteroide
ASTER3COLUNA   DB       50
ASTER4COLUNA   DB       70
ASTER1LINHA    DB        0             ;Linha atual do primeito asteroide
ASTER2LINHA    DB        0             ;Segundo asteroide
ASTER3LINHA    DB        0
ASTER4LINHA    DB        0
TEMPO          DW        0             ;Simulacao de um relogio interno
PAUSA          DW        0             ;Parar a execucao
PAUSA_LOOP     DW        0             ;Loop envolvendo o Pausa

LIMPATELA      PROC     NEAR
               PUSH     ES             ;Salva o segmento extra de dados
               MOV      AX,SegVideo    ;Endereco do segmento de video
               MOV      ES,AX          ;e passa para o ES
               MOV      DI,Zero        ;Deslocamento apos o ES
               MOV      CX,NumBytesVid ;Numero de bytes da tela (Preencher)
               MOV      AL,20H         ;AX 'Espaco' vai para a Tela
               MOV      AH,Atrib       ;Atributo de video normal
               REP      STOSW          ;Limpa a tela
               POP      ES             ;Retorna ES
               RET
LIMPATELA      ENDP

TIRACURSOR     PROC     NEAR
               MOV      CX,0808H       ;LinIni = 8 e LinFin = 8 (Some Cursor)
               MOV      AH,1           ;Setar tamanho do cursor
               INT      DOS10
               RET
TIRACURSOR     ENDP

POECURSOR      PROC     NEAR
               MOV      CX,0607H       ;LinIni = 6 e LinFin = 7 (Cursor Normal)
               MOV      AH,1           ;Setar tamanho do cursor
               INT      DOS10
               RET
POECURSOR      ENDP

POENAVE        PROC     NEAR
               PUSH     ES             ;Salva o segmento extra de dados
               MOV      AX,SegVideo    ;Endereco do segmento de video
               MOV      ES,AX          ;e passa para o ES
               MOV      AX,(80*2)*24   ;AX possui a ultima linha do video
               MOV      BH,ZERO        
               MOV      BL,NAVECOLUNA  ;Bx possui a coluna da nave
               ADD      AX,BX
               ADD      AX,BX          ;Caracter e atributo
               MOV      DI,AX          ;Deslocamento
               MOV      AL,Nave
                        STOSB          ;Mostre a nave
               POP      ES             ;Retorna ES
               RET
POENAVE        ENDP

TIRANAVE       PROC     NEAR
               PUSH     ES             ;Salva ES
               MOV      AX,SegVideo    ;O endereco de video B800H
               MOV      ES,AX          ;e passado para o ES
               MOV      AX,(80*2)*24   ;Ultima linha do video
               MOV      BH,ZERO
               MOV      BL,NAVECOLUNA  ;BX possui a coluna da nave
               ADD      AX,BX
               ADD      AX,BX          ;Caracter e Atributo
               MOV      DI,AX
               MOV      AL,Espaco      ;Apaga nave
                        STOSB
               POP      ES             ;Retorna ES
               RET
TIRANAVE       ENDP

DIREITANAVE    PROC     NEAR
               MOV      AL,79          ;Canto direito do video
               CMP      AL,NAVECOLUNA  ;Extrapolou o canto direito?
               JE       DIREITAFIM     ;Se sim entao pule
               CALL     TIRANAVE       ;Se nao tire a nave
               INC      NAVECOLUNA     ;Nova posicao
               CALL     POENAVE        ;Poe a nave na nova posicao
DIREITAFIM:    RET
DIREITANAVE    ENDP

ESQUERDANAVE   PROC     NEAR
               MOV      AL,0           ;Canto esquerdo do video
               CMP      AL,NAVECOLUNA  ;Extrapolou o canto direito
               JE       ESQUERDAFIM    ;Se sim entao pule
               CALL     TIRANAVE       ;Se nao entao tire a nave
               DEC      NAVECOLUNA     ;Nova posicao
               CALL     POENAVE        ;Poe a nave na nova posicao
ESQUERDAFIM:   RET
ESQUERDANAVE   ENDP

POETIRO        PROC     NEAR
               PUSH     ES             ;Salva ES
               MOV      AX,SegVideo
               MOV      ES,AX          ;ES aponta para o video
               MOV      AX,(80*2)      ;Numero de bytes por linha
               MOV      CL,TIROLINHA   ;Linha em que o tiro se encontra
               MUL      CL             ;Endereco da linha em que o tiro esta
               MOV      BH,ZERO
               MOV      BL,TIROCOLUNA  ;BX contem a coluna do tiro
               ADD      AX,BX          ;Caracter e atributo
               ADD      AX,BX          ;AX contem endereco do tiro
               MOV      DI,AX
               MOV      AL,Raio
                        STOSB          ;Mostra raio no endereco de ES:DI
               POP      ES             ;Retorna ES
               RET
POETIRO        ENDP

TIRATIRO       PROC     NEAR
               PUSH     ES
               MOV      AX,SegVideo    ;Idem POETIRO
               MOV      ES,AX
               MOV      AX,(80*2)
               MOV      CL,TIROLINHA
               MUL      CL
               MOV      BH,ZERO
               MOV      BL,TIROCOLUNA
               ADD      AX,BX
               ADD      AX,BX
               MOV      DI,AX
               MOV      AL,Espaco      ;Apagar o tiro corrente
                        STOSB
               POP      ES
               RET
TIRATIRO       ENDP

MOVETIRO       PROC     NEAR
               MOV      AL,ZERO        ;Topo da tela
               CMP      AL,TIROLINHA   ;O tiro chegou ao topo da tela?
               JNE      CONTINUA       ;Pule se nao chegou
               CALL     TIRATIRO       ;Se chegou tire o tiro
               MOV      TIROLINHA,24   ;Prepare para outro tiro
               RET
CONTINUA:      CALL     TIRATIRO       ;Tire o tiro corrente
               DEC      TIROLINHA      ;Avance o tiro
               CALL     POETIRO        ;Coloque-o na nova posicao
               RET
MOVETIRO       ENDP

CONTRNAVE      PROC     NEAR
               MOV      AH,0BH         ;Verifica o estado do teclado
               INT      DOS21
               CMP      AL,0           ;Tem tecla no buffer?
               JE       CONTRNAVEFIM   ;Se nao pule para o fim, senao
               MOV      AH,07          ;pege caracter direto do buffer sem eco
               INT      DOS21
CONTRNAVEFIM:  RET
CONTRNAVE      ENDP

CONTRTIRO      PROC     NEAR
               CMP      TIROLINHA,24   ;Existe um tiro em andamento?
               JE       NAOMOVE        ;Se nao continue
               CALL     MOVETIRO       ;Se sim entao mova-o
NAOMOVE:       RET
CONTRTIRO      ENDP

COLOCACARACT   PROC     NEAR
               PUSH     ES             ;Salva ES
               PUSH     AX
               MOV      AX,SegVideo
               MOV      ES,AX          ;ES aponta para o video
               MOV      AX,(80*2)      ;Numero de bytes por linha
               MUL      CL             ;Endereco da linha em que o tiro esta
               MOV      BH,ZERO
               ADD      AX,BX          ;Caracter e atributo
               ADD      AX,BX          ;AX contem endereco do tiro
               MOV      DI,AX
               POP      AX
                        STOSB          ;Mostra raio no endereco de ES:DI
               POP      ES             ;Retorna ES
               RET
COLOCACARACT   ENDP

COLOCAOBJETO   PROC     NEAR
               CMP      AH,1           ;Escolhe qual meteoro a ser impresso
               JE       AST1
               CMP      AH,2
               JE       AST2
               CMP      AH,3
               JE       AST3
               CMP      AH,4
               JE       AST4
               RET
AST1:          MOV      CL,ASTER1LINHA ;Primeiro asteroide
               MOV      BL,ASTER1COLUNA
               JMP      IMPRIME
AST2:          MOV      CL,ASTER2LINHA ;Segundo asteroide
               MOV      BL,ASTER2COLUNA
               JMP      IMPRIME
AST3:          MOV      CL,ASTER3LINHA ;Terceiro asteroide
               MOV      BL,ASTER3COLUNA
               JMP      IMPRIME
AST4:          MOV      CL,ASTER4LINHA ;Quarto asteroide
               MOV      BL,ASTER4COLUNA
IMPRIME:       CALL     COLOCACARACT
               RET
COLOCAOBJETO   ENDP

CRIACOLUNA     PROC     NEAR
NOVOVALOR:     ADD      AL,17          ;Escolhe uma coluna entre 0 e 79
               CMP      AL,79          ;e a retorna em AL
               JA       NOVOVALOR
               RET
CRIACOLUNA     ENDP

PREPARAASTER   PROC     NEAR
               CMP      AH,1           ;Escolhe qual meteoro devera ser lancado
               JE       PEGA1
               CMP      AH,2
               JE       PEGA2
               CMP      AH,3
               JE       PEGA3
               CMP      AH,4
               JE       PEGA4
               RET
PEGA1:         MOV      AL,ASTER1COLUNA
               INC      ASTER1LINHA
               CALL     CRIACOLUNA
               MOV      ASTER1COLUNA,AL
               MOV      AL,Aster1
               CALL     COLOCAOBJETO
               JMP      FIMPREP
PEGA2:         MOV      AL,ASTER2COLUNA
               INC      ASTER2LINHA
               CALL     CRIACOLUNA
               MOV      ASTER2COLUNA,AL
               MOV      AL,Aster2
               CALL     COLOCAOBJETO
               JMP      FIMPREP
PEGA3:         MOV      AL,ASTER3COLUNA
               INC      ASTER3LINHA
               CALL     CRIACOLUNA
               MOV      ASTER3COLUNA,AL
               MOV      AL,Aster3
               CALL     COLOCAOBJETO
               JMP      FIMPREP
PEGA4:         MOV      AL,ASTER4COLUNA
               INC      ASTER4LINHA
               CALL     CRIACOLUNA
               MOV      ASTER4COLUNA,AL
               MOV      AL,Aster4
               CALL     COLOCAOBJETO
FIMPREP:       RET
PREPARAASTER   ENDP

CONTRASTER     PROC     NEAR
               MOV      AH,1          ;Primeiro asteroide
               CMP      ASTER1LINHA,0
               JNE      CONTINUA1
               CALL     PREPARAASTER  ;Lanca asteroide
               JMP      SALTA1
CONTINUA1:     MOV      AL,Espaco
               CALL     COLOCAOBJETO
               CMP      ASTER1LINHA,24
               JE       TIRA1
               INC      ASTER1LINHA   ;Nao chegou ao solo
               MOV      AL,Aster1
               CALL     COLOCAOBJETO
               JMP      SALTA1
TIRA1:         MOV      ASTER1LINHA,0 ;Retira o asteroide que chegou ao solo
SALTA1:        MOV      AH,2          ;Repete procedimento para o segundo ast.
               CMP      ASTER2LINHA,0
               JNE      CONTINUA2
               CALL     PREPARAASTER
               JMP      SALTA2
CONTINUA2:     MOV      AL,Espaco
               CALL     COLOCAOBJETO
               CMP      ASTER2LINHA,24
               JE       TIRA2
               INC      ASTER2LINHA
               MOV      AL,Aster2
               CALL     COLOCAOBJETO
               JMP      SALTA2
TIRA2:         MOV      ASTER2LINHA,0
SALTA2:        MOV      AH,3
               CMP      ASTER3LINHA,0
               JNE      CONTINUA3
               CALL     PREPARAASTER
               JMP      SALTA3
CONTINUA3:     MOV      AL,Espaco
               CALL     COLOCAOBJETO
               CMP      ASTER3LINHA,24
               JE       TIRA3
               INC      ASTER3LINHA
               MOV      AL,Aster3
               CALL     COLOCAOBJETO
               JMP      SALTA3
TIRA3:         MOV      ASTER3LINHA,0
SALTA3:        MOV      AH,4
               CMP      ASTER4LINHA,0
               JNE      CONTINUA4
               CALL     PREPARAASTER
               JMP      SALTA4
CONTINUA4:     MOV      AL,Espaco
               CALL     COLOCAOBJETO
               CMP      ASTER4LINHA,24
               JE       TIRA4
               INC      ASTER4LINHA
               MOV      AL,Aster4
               CALL     COLOCAOBJETO
               JMP      SALTA4
TIRA4:         MOV      ASTER4LINHA,0
SALTA4:        RET
CONTRASTER     ENDP

DESTROEASTER   PROC     NEAR
	  
               MOV      AL,Espaco
               CALL     COLOCAOBJETO   ;Apaga asteroide
               CMP      AH,1           ;Escolhe asteroide
               JE       APAGA1
               CMP      AH,2
               JE       APAGA2
               CMP      AH,3
               JE       APAGA3
               CMP      AH,4
               JNE      ERRO
               JMP      APAGA4
ERRO:          RET
APAGA1:        MOV      CL,ASTER1LINHA ;Mostra explosao e retira asteroide
               MOV      BL,ASTER1COLUNA
               MOV      AL,Explosao
               CALL     COLOCACARACT
               MOV      Pausa,0FFFFH
               CALL     ESPERE
               MOV      CL,ASTER1LINHA
               MOV      BL,ASTER1COLUNA
               MOV      AL,Espaco
               CALL     COLOCACARACT
               MOV      AL,ASTER1COLUNA
               CALL     CRIACOLUNA
               MOV      ASTER1COLUNA,AL
               MOV      ASTER1LINHA,0
               MOV      TIROLINHA,24
               RET
APAGA2:        MOV      CL,ASTER2LINHA
               MOV      BL,ASTER2COLUNA
               MOV      AL,Explosao
               CALL     COLOCACARACT
               MOV      Pausa,0FFFFH
               CALL     ESPERE
               MOV      CL,ASTER2LINHA
               MOV      BL,ASTER2COLUNA
               MOV      AL,Espaco
               CALL     COLOCACARACT
               MOV      AL,ASTER2COLUNA
               CALL     CRIACOLUNA
               MOV      ASTER2COLUNA,AL
               MOV      ASTER2LINHA,0
               MOV      TIROLINHA,24
               RET
APAGA3:        MOV      CL,ASTER3LINHA
               MOV      BL,ASTER3COLUNA
               MOV      AL,Explosao
               CALL     COLOCACARACT
               MOV      Pausa,0FFFFH
               CALL     ESPERE
               MOV      CL,ASTER3LINHA
               MOV      BL,ASTER3COLUNA
               MOV      AL,Espaco
               CALL     COLOCACARACT
               MOV      AL,ASTER3COLUNA
               CALL     CRIACOLUNA
               MOV      ASTER3COLUNA,AL
               MOV      ASTER3LINHA,0
               MOV      TIROLINHA,24
               RET
APAGA4:        MOV      CL,ASTER4LINHA
               MOV      BL,ASTER4COLUNA
               MOV      AL,Explosao
               CALL     COLOCACARACT
               MOV      Pausa,0FFFFH
               CALL     ESPERE
               MOV      CL,ASTER4LINHA
               MOV      BL,ASTER4COLUNA
               MOV      AL,Espaco
               CALL     COLOCACARACT
               MOV      AL,ASTER4COLUNA
               CALL     CRIACOLUNA
               MOV      ASTER4COLUNA,AL
               MOV      ASTER4LINHA,0
               MOV      TIROLINHA,24
               RET
DESTROEASTER   ENDP

CONTRINPACTO   PROC     NEAR
               MOV      AL,TIROCOLUNA  ;Verifica colisao entre tiro e ast.
               MOV      AH,TIROLINHA
               CMP      AL,ASTER1COLUNA
               JNE      VERIF1
               CMP      AH,ASTER1LINHA
               JNE      VERIF1
               MOV      AH,1
               CALL     DESTROEASTER
VERIF1:        CMP      AL,ASTER2COLUNA
               JNE      VERIF2
               CMP      AH,ASTER2LINHA
               JNE      VERIF2
               MOV      AH,2
               CALL     DESTROEASTER
VERIF2:        CMP      AL,ASTER3COLUNA
               JNE      VERIF3
               CMP      AH,ASTER3LINHA
               JNE      VERIF3
               MOV      AH,3
               CALL     DESTROEASTER
VERIF3:        CMP      AL,ASTER4COLUNA
               JNE      VERIF4
               CMP      AH,ASTER4LINHA
               JNE      VERIF4
               MOV      AH,4
               CALL     DESTROEASTER
VERIF4:        RET
CONTRINPACTO   ENDP

ESPERE         PROC     NEAR
	       PUSH     CX
               MOV      Pausa_Loop,00212H
LOOP_PRINC:    DEC      Pausa_Loop
               MOV      CX,Pausa_Loop
	       JCXZ     SAI_LP_PRINC  ;Sai do loop principal

               MOV      Pausa,0FF00H
VOLTACONTAR:   DEC      Pausa
               MOV      CX,Pausa
               JCXZ     SAI_LOOP  ;Sai quando Pausa for zero
               JMP      VOLTACONTAR

SAI_LOOP:      JMP LOOP_PRINC
SAI_LP_PRINC:  POP      CX
	       RET
ESPERE         ENDP

DESTROENAVE    PROC     NEAR
               MOV      CL,24          ;Coloca explosao e chama ESPERA
               MOV      BL,NAVECOLUNA
               MOV      AL,Explosao
               CALL     COLOCACARACT
               MOV      Pausa,04000H
               CALL     ESPERE
               MOV      CL,24
               MOV      BL,NAVECOLUNA
               MOV      AL,Nave
               CALL     COLOCACARACT
               RET
DESTROENAVE    ENDP

NAVEDESTR      PROC     NEAR
               MOV      AL,NAVECOLUNA  ;Compara posicoes dos asteroide
                                       ;com o da nave
               MOV      AH,24
               CMP      AL,ASTER1COLUNA
               JNE      VERIFNAV1
               CMP      AH,ASTER1LINHA
               JNE      VERIFNAV1
               MOV      AH,1
               MOV      ASTER1LINHA,0
               CALL     DESTROENAVE
VERIFNAV1:     CMP      AL,ASTER2COLUNA
               JNE      VERIFNAV2
               CMP      AH,ASTER2LINHA
               JNE      VERIFNAV2
               MOV      AH,2
               MOV      ASTER2LINHA,0
               CALL     DESTROENAVE
VERIFNAV2:     CMP      AL,ASTER3COLUNA
               JNE      VERIFNAV3
               CMP      AH,ASTER3LINHA
               JNE      VERIFNAV3
               MOV      AH,3
               MOV      ASTER3LINHA,0
               CALL     DESTROENAVE
VERIFNAV3:     CMP      AL,ASTER4COLUNA
               JNE      VERIFNAV4
               CMP      AH,ASTER4LINHA
               JNE      VERIFNAV4
               MOV      AH,4
               MOV      ASTER4LINHA,0
               CALL     DESTROENAVE
VERIFNAV4:     RET
NAVEDESTR      ENDP

CONTROLE       PROC     NEAR
               CALL     LIMPATELA
               CALL     TIRACURSOR
               CALL     POENAVE
VOLTA:         MOV      TEMPO,00001H
CONTA:         DEC      TEMPO
	       CALL     ESPERE
               MOV      CX,TEMPO
               JCXZ     LIBERA
               JMP      CONTA
LIBERA:        CALL     CONTRASTER
               CALL     CONTRINPACTO
               CALL     CONTRTIRO
               CALL     CONTRINPACTO
               CALL     NAVEDESTR
PULA0:         CALL     CONTRNAVE      ;Verifica o teclado
               CMP      AL,Direita     ;Comanto para ir para a direita?
               JNE      PULA1          ;Se nao for entao pule
               CALL     DIREITANAVE    ;Se sim mova para a direita
               JMP      VOLTA          
PULA1:         CMP      AL,Esquerda    ;Verificar se e para ir para a esquerda
               JNE      PULA2
               CALL     ESQUERDANAVE
               JMP      VOLTA
PULA2:         CMP      AL,Espaco      ;E para disparar um tiro?
               JNE      PULA3          ;Se nao entao pule
               MOV      AL,TIROLINHA
               CMP      AL,24          ;Se sim, existe um tiro em andamento?
               JNE      VOLTA          ;Se sim entao nao dispare mais um
               DEC      TIROLINHA      ;Se nao habilite o uso do MOVETIRO
               MOV      AH,NAVECOLUNA
               MOV      TIROCOLUNA,AH  ;Informa a coluna do tiro
               CALL     POETIRO
               JMP      VOLTA
PULA3:         CMP      AL,EnterKey    ;E comando para sair
               JE       FIM            ;Se sim entao fim.
               JMP      VOLTA
FIM:           CALL     POECURSOR
               CALL     LIMPATELA
               RET
CONTROLE       ENDP

CODIGO         ENDS
               END      INICIO
